<!DOCTYPE html> 
<html>
	<head>
		<meta charset="utf-8"/>
		<title>JsEOQ Basic Web Socket Example</title>
		<script src="contrib/jquery/jquery-3.3.1.min.js"></script>
		<!-- EOQ includes -->
		<script src="../eoq2/query/query.js"></script>
		<script src="../eoq2/command/command.js"></script>
		<script src="../eoq2/eoq2.js"></script>
		<script src="../eoq2/util/logger.js"></script>
		<script src="../eoq2/command/result.js"></script>
		<script src="../eoq2/frame/frame.js"></script>
		<script src="../eoq2/event/event.js"></script>
		<script src="../eoq2/domain/domain.js"></script>
		<script src="../eoq2/serialization/serializer.js"></script>
		<script src="../eoq2/serialization/jsonserializer.js"></script>
		<script src="../eoq2/serialization/textserializer.js"></script>
		<script src="../eoq2/domain/remote/websocketdomain.js"></script>
		<script>
			async function BasicWebSocketExample() {
				let webSocketUrl = 'ws://localhost:8000/ws/eoq.do';
				let serializer = new eoq2.serialization.TextSerializer();
	
				//initialize the domain
				let domain = new eoq2.domain.remote.WebSocketDomain(webSocketUrl,logger=new eoq2.util.NoLogging());
	
				await domain.Open();
	
				//Get all elements of class article contained in the model
				let result = await domain.Do( CMD.Get(QRY.Cls('Article')));
				Print("result: "+serializer.Ser(result));
    
				//Set article name to Apple
				result = await domain.Do( CMD.Set(QRY.Cls('Article'),'name','Apple'));
				Print("result: "+serializer.Ser(result));
    
				//Get the name property of all articles
				result = await domain.Do(CMD.Get(QRY.Cls('Article').Pth('name')));
				Print("result: "+serializer.Ser(result));
    
				//Get all constraints in the workspace
				result = await domain.Do(CMD.Gac());
				Print("result: "+serializer.Ser(result));
    
				//Add first and second constraint
				let result1 = await domain.Do(CMD.Adc('HARD','!Article','name','&RGX\'\\w+\'','fivth_constraint','All Article name should follow backslashw+'));
				let result2 = await domain.Do(CMD.Adc('SOFT','!Article','name','=Apple','sixth_constraint','All Article name should equal Apple'));
				Print("result: "+serializer.Ser(result1));
				Print("result: "+serializer.Ser(result2));
    
				//Get all constraints for class Article
				result = await domain.Do(CMD.Get(QRY.Cls('Article').Idx(0).Cns()));
				Print("result: "+serializer.Ser(result));
    
				//Get all constraints
				result = await domain.Do(CMD.Gac());
				Print("result: "+serializer.Ser(result));
    
				//Validate all constraints
				result = await domain.Do(CMD.Val(null));
				Print("result: "+serializer.Ser(result));
    
				//Violate HARD constraint
				try{
				result = await domain.Do(CMD.Set(QRY.Cls('Article'),'name','!!!!'));
				Print("result: "+serializer.Ser(result));
				} catch(e){
				Print("Violated HARD constraint");
				}

				//Get Articles new name
				result = await domain.Do(CMD.Get(QRY.Cls('Article').Pth('name')));
				Print("result: "+serializer.Ser(result));

				//Remove all constraints
				result = await domain.Do(CMD.Rmc(QRY.Cls('Article').Idx(0).Cns()));
				Print("result: "+serializer.Ser(result));

				//Get all constraints
				result = await domain.Do(CMD.Gac());
				Print("result: "+serializer.Ser(result));
			}	

			//Define a local print function to print return values assynchrounously to the HTML DOM
			function Print(msg) {
				$("#output").append('<div >'+ msg + '</div>');
			}
		
		</script>
	</head> 
	<body onload="BasicWebSocketExample();">
		<div id="output">
			<!-- all output goes here -->
		</div>
	</body>
</html>